function populationstatistics(s,p,nx,nz)
  [m n] = size(p);
  feasible = p(end,:) <= 0;
  nfeasible = sum(feasible);
  infeasible = p(end,:) >= 0;
  ninfeasible = sum(infeasible);
  fprintf('Population statistics for %s:\n', s)
  fprintf(': there are %d members of which %d are feasible.\n', n, nfeasible)
  fprintf(': min objective function values: ')
  fprintf('%g ', min(p(nx+1:nx+nz,:),[],2))
  fprintf('\n');
  if nfeasible > 0
    fprintf(': constraint values for feasible solutions in [%g,%g]\n', ...
           min(p(end,feasible)), max(p(end,feasible)));
  end
  if ninfeasible > 0
    fprintf(': constraint values for infeasible solutions in [%g,%g]\n', ...
           min(p(end,infeasible)), max(p(end,infeasible)));
  end
end
