function pruned = strawberry_prune (pop, nx, nz)
  global npruned
  global strawberry_diversity_tolerance
  npop = size(pop,2);
  if npop > 0
    pruned = pop(:,1);
    np = 1;                       % size of pruned set
    for i=2:npop
      diverse = 1;
      j = 0;
      while diverse && j < np
        j = j + 1;
        %% diversity based on x values alone
        diverse = norm (pop(1:nx,i)-pruned(1:nx,j)) > strawberry_diversity_tolerance;
        %% fprintf('div(%d,%d)=%g %d\r', i, j, norm (pop(1:nx,i)-pruned(1:nx,j)), diverse);
      end
      if diverse
        pruned = [pruned, pop(:,i)];
        np = np + 1;            %keep track of how many copied over
      else
        %% prune one or the other.  ideally, we keep the better
        %% one.  If we cannot distinguish (in a multi-objective
        %% sense), we simply keep the one that is already there. 
        npruned = npruned + 1;
        if ~ dominates(pruned(nx+1:nx+nz,j),pop(nx+1:nx+nz,i))
          if dominates(pop(nx+1:nx+nz,i),pruned(nx+1:nx+nz,j))
            %% current solution is better, i.e. dominates, than previous
            %% one so replace
            pruned(:,j) = pop(:,i);
          end
        end
      end
    end
  end
end
